BEGIN;

-- 1.0.3 -> 1.0.4
-- issue1994: Fügt eine neue Option in viele der Felder unter Kooperationsbezug
-- ein

SET ROLE :db_adm;

INSERT INTO db_history (beschreibung, zeitpunkt)
    VALUES ('1.0.4/02-kooperationsbezug.sql', current_timestamp);

-- ----------------------------------------------------------
-- Create/update tables with the new "nicht relevant" value
-- ----------------------------------------------------------
INSERT INTO jmd_erreicht_andere_durchfuehrung_tbl (id, value)
    VALUES ('5', 'nicht relevant');


CREATE TABLE jmd_nimmt_an_verstaltungen_teil_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(14) NOT NULL
);

INSERT INTO jmd_nimmt_an_verstaltungen_teil_tbl (id, value) VALUES (-3, 'Unbekannt');
INSERT INTO jmd_nimmt_an_verstaltungen_teil_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO jmd_nimmt_an_verstaltungen_teil_tbl (id, value) VALUES (0, 'Nein');
INSERT INTO jmd_nimmt_an_verstaltungen_teil_tbl (id, value) VALUES (1, 'Ja');
INSERT INTO jmd_nimmt_an_verstaltungen_teil_tbl (id, value) VALUES (2, 'nicht relevant');

GRANT SELECT ON jmd_nimmt_an_verstaltungen_teil_tbl TO GROUP :cm_group;
GRANT SELECT ON jmd_nimmt_an_verstaltungen_teil_tbl TO GROUP :admin_group;




-- ----------------------------------------------------------
-- Change the Foreign Keys to point to the new tables
-- ----------------------------------------------------------
ALTER TABLE rg_kooperationsbezug_tbl
    DROP CONSTRAINT rg_kooperationsbezug_tbl_jmd_nimmt_an_verstaltungen_teil_fkey,
    ADD FOREIGN KEY (jmd_nimmt_an_verstaltungen_teil) REFERENCES jmd_nimmt_an_verstaltungen_teil_tbl (id),
    
    DROP CONSTRAINT rg_kooperationsbezug_tbl_jmd_fuehrt_beratung_durch_fkey,
    ADD FOREIGN KEY (jmd_fuehrt_beratung_durch) REFERENCES jmd_nimmt_an_verstaltungen_teil_tbl (id),
    
    DROP CONSTRAINT rg_kooperationsbezug_tbl_kooperation_schriftlich_festgeleg_fkey,
    ADD FOREIGN KEY (kooperation_schriftlich_festgelegt) REFERENCES jmd_nimmt_an_verstaltungen_teil_tbl (id);


-- ----------------------------------------------------------
-- Finish
-- ----------------------------------------------------------
SET ROLE postgres;

-- ROLLBACK;
COMMIT;
