BEGIN;
-- issue2331: Tagging einfuehren

-- Start, disable triggers and set role
ALTER TABLE tags DISABLE TRIGGER ALL;
SET ROLE :db_adm;

INSERT INTO db_history (beschreibung, zeitpunkt)
VALUES ('1.1.2/01_tagging.sql', current_timestamp);

-- Autogenerated tag insert statements

DELETE FROM tags;
INSERT INTO tags (id, label, description) VALUES (0, 'Alle', 'Jede Statistik hat einen Tag');
INSERT INTO tags (id, label, description) VALUES (1, 'Grundsätzlich Auswertbar', 'Die JMD-Statistik ist konsistent und weist die benötigten Validitäten auf, die für eine grundsätzliche Auswertung erfüllt sein müssen. Die Statistik steht in Auswertungen zur Verfügung');
INSERT INTO tags (id, label, description) VALUES (2, 'Auswertbar', 'Die JMD-Statistik ist grundsätzlich auswertbar, darüber hinaus wurde sie als vollständig markiert (die Checkbox auf Seite 5 ist gesetzt).');
INSERT INTO tags (id, label, description) VALUES (10, 'Datumsangaben konsistent', 'Alle Datumsangaben in der Statistik befinden sich in chronologisch korrekter Reihenfolge und liegen nicht in der Zukunft');
INSERT INTO tags (id, label, description) VALUES (11, 'Status der Erfassung gesetzt', 'Der Status der Erfassung der Statistik muss "Erfassung Beendet" sein');
INSERT INTO tags (id, label, description) VALUES (12, 'Angaben vollständig', 'Die Angaben sind vollständig und sollen ausgewertet werden (die Checkbox auf Seite 5 ist angekreuzt).');
INSERT INTO tags (id, label, description) VALUES (100, 'Doppelte JMD-Statistik', 'Es darf nur eine JMD-Statistik pro Jahr angelegt werden. Doppelte Statistiken
werden nicht bei der Auswertung berücksichtigt.');
INSERT INTO tags (id, label, description) VALUES (101, 'Start- und Enddaten gesetzt', 'Die Angaben zum Start und Ende des Zeitraums müssen angegeben werden.');
INSERT INTO tags (id, label, description) VALUES (1000, 'Das Datum "Datum Beginn Zeitraum" darf nicht "unbekannt" sein.', 'Das Datum "Datum Beginn Zeitraum" darf nicht "unbekannt" sein.');
INSERT INTO tags (id, label, description) VALUES (1001, 'Das Datum "Datum Ende Zeitraum" darf nicht "unbekannt" sein.', 'Das Datum "Datum Ende Zeitraum" darf nicht "unbekannt" sein.');
INSERT INTO tags (id, label, description) VALUES (1002, '"datum_begin_zeitraum" muss vor "datum_ende_zeitraum" liegen.', '"Datum Beginn Zeitraum" darf zeitlich nicht nach "Datum Ende Zeitraum" liegen.');
INSERT INTO tags (id, label, description) VALUES (1003, 'Summe der prozentualen Verteilung der Arbeitsanteile auf Aufgabenbereiche muss 100 Prozent sein', 'Summe der prozentualen Verteilung der Arbeitsanteile auf Aufgabenbereiche muss 100 Prozent sein');



-- Finish, re-enable the triggers
SET ROLE postgres;
ALTER TABLE tags ENABLE TRIGGER ALL;

COMMIT;
--ROLLBACK;
