BEGIN;
-- Issue1844: Einrichten der Anonymview. Diese view fehlt auf vielen der
-- Produktiven Datenbanken. 
ALTER TABLE master_tbl DISABLE TRIGGER USER;
SET ROLE :db_adm;

INSERT INTO db_history (beschreibung, zeitpunkt)
VALUES ('1.0.2/01_anonymview.sql', current_timestamp);

CREATE OR REPLACE VIEW master_tbl_anonym_view
AS SELECT
    id,
    uuid_id,
    bearbeiter_id,
    fkz,
    einwilligung,
    datum_ea_ende,
    phase,
    NULL::VARCHAR(60) AS jmd_name,
    geburtsdatum,
    geschlecht,
    aufenthaltsstatus,
    angaben_aufenthaltsstatus,
    datum_ea_start,
    zugang,
    nennung_zugang,
    war_bereits_kunde,
    NULL::VARCHAR(256) AS nennung_einrichtung_cm,
    weitergabe_an_dritte,
    kooperation_mit_dritten,
    art_begleitung,
    datum_cm_start,
    datum_ber_start,
    datum_ber_ende,
    NULL::VARCHAR(256) AS name,
    NULL::VARCHAR(256) AS vorname,
    NULL::VARCHAR(256) AS geburtsname,
    NULL::VARCHAR(256) AS name_vor_einbuergerung,
    geburtsland,
    NULL::VARCHAR(60) AS geburtsland_nennung,
    NULL::VARCHAR(60) AS geburtsort,
    NULL::VARCHAR(60) AS fuehrerschein,
    familienstand,
    alleinerziehend,
    anzahl_geschwister,
    NULL::TEXT AS weitere_angaben_kinder,
    staatsangehoerigkeit,
    NULL::VARCHAR(60) AS staatsangehoerigkeit_nennung,
    staatsangehoerigkeit_weitere,
    NULL::VARCHAR(60) AS staatsangehoerigkeit_weitere_nennung,
    einreisedatum,
    muttersprache,
    NULL::VARCHAR(60) AS muttersprache_nennung,
    sprache_zuhause,
    NULL::VARCHAR(60) AS sprache_zuhause_nennung,
    mutter_geburtsland,
    vater_geburtsland,
    wohnsituation,
    NULL::TEXT AS wohnsituation_konkretisierung,
    bezugsperson_a,
    bezugsperson_b,
    bezugsperson_c,
    bezugsperson_d,
    bezugsperson_e,
    bezugsperson_s,
    bezugsperson_f,
    bezugsperson_g,
    bezugsperson_h,
    bezugsperson_i,
    bezugsperson_j,
    bezugsperson_k,
    bezugsperson_l,
    bezugsperson_m,
    bezugsperson_n,
    bezugsperson_o,
    bezugsperson_p,
    bezugsperson_q,
    bezugsperson_r,
    NULL::TEXT AS bezugsperson_weitere_angaben,
    zugeh_a,
    zugeh_b,
    zugeh_c,
    zugeh_d,
    zugeh_e,
    NULL::TEXT AS soz_engagement,
    NULL::TEXT AS hobbies,
    einkommen_familie,
    einkommen_jugendlicher,
    geldmittel,
    schulden,
    schulden_beratung,
    NULL::TEXT AS anmerkungen_finanzsituation,
    psychische_beeintraechtigung,
    physische_beeintraechtugung,
    sucht,
    NULL::TEXT AS anmerkungen_gensundsituation,
    aktuelle_situation,
    NULL::VARCHAR(60) AS aktuelle_situation_nennung,
    aktuelle_schule,
    aktuelle_schule_klassenstufe,
    NULL::VARCHAR(60) AS aktueller_beruf,
    aktueller_beruf_ausbildungsjahr,
    aktuelle_massnahme_art,
    NULL::VARCHAR(60) AS aktuelle_massnahme_art_nennung,
    NULL::VARCHAR(60) AS aktuelle_massnahme,
    aktuelle_massnahme_beginn,
    aktuelle_massnahme_dauer,
    NULL::VARCHAR(60) AS aktuelle_taetigkeit,
    aktuelle_taetigkeit_datum_seit,
    aktuelle_arbeitslosigkeit_seit,
    aktuelle_elternzeit_seit,
    aktueller_zivildienst_seit,
    hoechster_schulabschluss,
    NULL::VARCHAR(60) AS hoechster_schulabschluss_nennung,
    NULL::VARCHAR(60) AS hoechster_schulabschluss_ausland,
    hoechster_schulabschluss_ausland_anerkannt,
    hoechster_schulabschluss_ausland_land,
    NULL::TEXT AS weitere_angaben_schulabschluss,
    hoechster_berufsabschluss,
    NULL::VARCHAR(60) AS hoechster_berufsabschluss_nennung,
    NULL::VARCHAR(60) AS hoechster_berufsabschluss_ausland,
    hoechster_berufsabschluss_ausland_anerkannt,
    hoechster_berufsabschluss_ausland_land,
    NULL::TEXT AS weitere_angaben_berufsabschluss,
    integrationskurs,
    datum_integrationskurs_ende,
    kompetenzfeststellung,
    kf_verfahren,
    kf_verfahren_nennung,
    kf_erg_natur_a,
    kf_erg_natur_b,
    kf_erg_natur_c,
    kf_erg_natur_d,
    kf_erg_natur_e,
    kf_erg_medien_a,
    kf_erg_medien_b,
    kf_erg_medien_c,
    kf_erg_medien_d,
    kf_erg_medien_e,
    kf_erg_handwerk_a,
    kf_erg_handwerk_b,
    kf_erg_handwerk_c,
    kf_erg_handwerk_d,
    kf_erg_methode_a,
    kf_erg_methode_b,
    kf_erg_methode_c,
    kf_erg_methode_d,
    kf_erg_methode_e,
    kf_erg_methode_f,
    kf_erg_methode_g,
    kf_erg_deutsch_a,
    kf_erg_deutsch_b,
    kf_erg_deutsch_c,
    kf_erg_deutsch_d,
    kf_erg_sozial_a,
    kf_erg_sozial_b,
    kf_erg_sozial_c,
    kf_erg_sozial_d,
    kf_erg_sozial_e,
    kf_erg_sozial_f,
    kf_erg_sozial_g,
    kf_erg_sozial_h,
    kf_erg_sozial_i,
    kf_erg_sozial_j,
    kf_erg_selbst_a,
    kf_erg_selbst_b,
    kf_erg_selbst_c,
    kf_erg_selbst_d,
    kf_erg_selbst_e,
    kf_erg_selbst_f,
    kf_erg_selbst_g,
    kf_erg_selbst_h,
    kf_erg_selbst_i,
    kf_erg_selbst_j,
    kf_erg_selbst_k,
    kf_erg_leistung_a,
    kf_erg_leistung_b,
    kf_erg_leistung_c,
    kf_erg_leistung_d,
    kf_erg_leistung_e,
    kf_erg_leistung_f,
    kf_erg_leistung_g,
    kf_erg_leistung_h,
    kf_erg_leistung_i,
    kf_erg_leistung_j,
    kf_erg_leistung_k,
    datum_cm_ende,
    art_cm_ende,
    abbruch_durch,
    abbruch_durch_nennung,
    gruende_abbruch_cm,
    NULL::VARCHAR(60) AS gruende_abbruch_cm_nennung,
    veraenderung_inst_einbindung,
    ende_inst_einbindung,
    NULL::VARCHAR(60) AS ende_inst_einbindung_nennung,
    datum_verbleib_feststellung,
    verbleib_jugendliche,
    NULL::VARCHAR(60) AS verbleib_jugendliche_sonstiges FROM master_tbl_view;

CREATE OR REPLACE RULE master_tbl_anonym_delete_rule AS ON DELETE TO master_tbl_anonym_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE master_tbl_anonym_insert_rule AS ON INSERT TO master_tbl_anonym_view
    DO INSTEAD NOTHING;

GRANT SELECT ON master_tbl_anonym_view TO GROUP :cm_group;
GRANT SELECT ON master_tbl_anonym_view TO GROUP :admin_group;

-- Finish
SET ROLE postgres;
ALTER TABLE master_tbl ENABLE TRIGGER ALL;
COMMIT;
