-- Only needs to be excuted one time
\connect postgres postgres

UPDATE pg_database SET datallowconn = TRUE where datname='mpuls_template';

\connect mpuls_template postgres

BEGIN;
CREATE OR REPLACE FUNCTION mpuls_passgen(pw_length int) RETURNS text 
  LANGUAGE 'plpythonu' VOLATILE
  AS $$
    from os import popen
    from random import sample 
    pw = None
    try:
      try:
        pw = popen("/usr/bin/pwgen --ambiguous --numerals --secure %s"
                    % pw_length)
        return pw.readline().strip()
      except:
        pop = [chr(c) for c in range(33,127+1)]
        return "".join(sample(pop, pw_length)) 
    finally:
      if pw:
        try: pw.close()
        except: pass
$$;
COMMIT;

ALTER FUNCTION mpuls_passgen(int) OWNER TO mpuls_role_adm;
REVOKE ALL ON FUNCTION mpuls_passgen(int) FROM public;

UPDATE pg_database SET datallowconn = FALSE where datname='mpuls_template';

\connect mpuls_maintenance postgres
-- Passwortgenerator variabler Länge. Nutzt pwgen, um konforme Passworte zu
-- generieren
BEGIN;
CREATE OR REPLACE FUNCTION mpuls_passgen(pw_length int) RETURNS text 
  LANGUAGE 'plpythonu' VOLATILE
  AS $$
    from os import popen
    from random import sample 
    pw = None
    try:
      try:
        pw = popen("/usr/bin/pwgen --ambiguous --numerals --secure %s"
                    % pw_length)
        return pw.readline().strip()
      except:
        pop = [chr(c) for c in range(33,127+1)]
        return "".join(sample(pop, pw_length)) 
    finally:
      if pw:
        try: pw.close()
        except: pass
$$;

ALTER FUNCTION mpuls_passgen(int) OWNER TO pt_dlr;
REVOKE ALL ON FUNCTION mpuls_passgen(int) FROM public;
COMMIT;
