-- Projekt 2883: Rework documentation of Schulabschlüsse and Berufsabschlüsse

--
-- mpuls/issue5980: „Höchster in Deutschland erworbener Abschluss“
--

-- Schulabschluss
CREATE TABLE hoechster_schulabschluss_erworben_de_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(52) NOT NULL
);

INSERT INTO hoechster_schulabschluss_erworben_de_tbl (id, value) VALUES (-4, 'Unbekannt (Altdaten)');
INSERT INTO hoechster_schulabschluss_erworben_de_tbl (id, value) VALUES (-3, 'Unbekannt');
INSERT INTO hoechster_schulabschluss_erworben_de_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO hoechster_schulabschluss_erworben_de_tbl (id, value) VALUES (0, 'Ohne allgemeinen Schulabschluss');
INSERT INTO hoechster_schulabschluss_erworben_de_tbl (id, value) VALUES (1, 'Förderschule/Sonderschule beendet');
INSERT INTO hoechster_schulabschluss_erworben_de_tbl (id, value) VALUES (2, 'Abschluss Sek I');
INSERT INTO hoechster_schulabschluss_erworben_de_tbl (id, value) VALUES (5, 'Abschluss Sek II');
INSERT INTO hoechster_schulabschluss_erworben_de_tbl (id, value) VALUES (9, 'Kein Abschluss, weil noch in schulischer Ausbildung');

GRANT SELECT ON hoechster_schulabschluss_erworben_de_tbl TO GROUP :cm_group;
GRANT SELECT ON hoechster_schulabschluss_erworben_de_tbl TO GROUP :admin_group;

ALTER TABLE master_tbl
  ADD COLUMN hoechster_schulabschluss_erworben_de INTEGER DEFAULT -1,
  ADD FOREIGN KEY (hoechster_schulabschluss_erworben_de) 
      REFERENCES hoechster_schulabschluss_erworben_de_tbl (id); 

-- Update all existing data 

UPDATE master_tbl 
  SET weitere_angaben_schulabschluss = weitere_angaben_schulabschluss||E'\r\n'||
      'Altdaten „Höchster in Deutschland anerkannter Abschluss” (Schule):'||E'\r\n'||
      (SELECT value FROM hoechster_schulabschluss_tbl where id = hoechster_schulabschluss)
  WHERE hoechster_schulabschluss != -1 AND weitere_angaben_schulabschluss IS NOT NULL;

UPDATE master_tbl 
  SET weitere_angaben_schulabschluss = 
      'Altdaten „Höchster in Deutschland anerkannter Abschluss” (Schule):'||E'\r\n'||
      (SELECT value FROM hoechster_schulabschluss_tbl where id = hoechster_schulabschluss)
  WHERE hoechster_schulabschluss != -1 AND weitere_angaben_schulabschluss IS NULL;

UPDATE master_tbl
  SET hoechster_schulabschluss_erworben_de = -4
  WHERE  hoechster_schulabschluss != -1;



-- Berufsabschluss
CREATE TABLE hoechster_berufsabschluss_erworben_de_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(52) NOT NULL
);

INSERT INTO hoechster_berufsabschluss_erworben_de_tbl (id, value) VALUES (-4, 'Unbekannt (Altdaten)');
INSERT INTO hoechster_berufsabschluss_erworben_de_tbl (id, value) VALUES (-3, 'Unbekannt');
INSERT INTO hoechster_berufsabschluss_erworben_de_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO hoechster_berufsabschluss_erworben_de_tbl (id, value) VALUES (0, 'Ohne beruflichen Abschluss');
INSERT INTO hoechster_berufsabschluss_erworben_de_tbl (id, value) VALUES (1, 'Anlernqualifikation / Einstiegsqualifizierung');
INSERT INTO hoechster_berufsabschluss_erworben_de_tbl (id, value) VALUES (2, 'betriebliche Ausbildung');
INSERT INTO hoechster_berufsabschluss_erworben_de_tbl (id, value) VALUES (3, 'außerbetriebliche Ausbildung');
INSERT INTO hoechster_berufsabschluss_erworben_de_tbl (id, value) VALUES (4, 'Fachwirt/in (IHK), Meister/in (IHK, HWK)');
INSERT INTO hoechster_berufsabschluss_erworben_de_tbl (id, value) VALUES (5, 'Bachelor, Diplom (FH)');
INSERT INTO hoechster_berufsabschluss_erworben_de_tbl (id, value) VALUES (6, 'Master / M.A / Diplom (Universität)');
INSERT INTO hoechster_berufsabschluss_erworben_de_tbl (id, value) VALUES (7, 'sonstiger Abschluss');
INSERT INTO hoechster_berufsabschluss_erworben_de_tbl (id, value) VALUES (8, 'Kein Abschluss, weil noch in beruflicher Ausbildung');

GRANT SELECT ON hoechster_berufsabschluss_erworben_de_tbl TO GROUP :cm_group;
GRANT SELECT ON hoechster_berufsabschluss_erworben_de_tbl TO GROUP :admin_group;

ALTER TABLE master_tbl
  ADD COLUMN hoechster_berufsabschluss_erworben_de INTEGER DEFAULT -1,
  ADD FOREIGN KEY (hoechster_berufsabschluss_erworben_de) 
      REFERENCES hoechster_berufsabschluss_erworben_de_tbl (id);

ALTER TABLE master_tbl
  ADD COLUMN hoechster_berufsabschluss_erworben_de_nennung VARCHAR(60);

-- Update all existing data 

UPDATE master_tbl 
  SET weitere_angaben_berufsabschluss = weitere_angaben_berufsabschluss||E'\r\n'||
      'Altdaten „Höchster in Deutschland anerkannter Abschluss” (Beruf):'||E'\r\n'||
      (SELECT value FROM hoechster_berufsabschluss_tbl where id = hoechster_berufsabschluss)
  WHERE hoechster_berufsabschluss != -1 AND weitere_angaben_berufsabschluss IS NOT NULL;

UPDATE master_tbl 
  SET weitere_angaben_berufsabschluss = 
      'Altdaten „Höchster in Deutschland anerkannter Abschluss” (Beruf):'||E'\r\n'||
      (SELECT value FROM hoechster_berufsabschluss_tbl where id = hoechster_berufsabschluss)
  WHERE hoechster_berufsabschluss != -1 AND weitere_angaben_berufsabschluss IS NULL;

UPDATE master_tbl 
  SET weitere_angaben_berufsabschluss = weitere_angaben_berufsabschluss||E'\r\n'||
      hoechster_berufsabschluss_nennung
  WHERE hoechster_berufsabschluss = 7 AND hoechster_berufsabschluss_nennung IS NOT NULL;


UPDATE master_tbl
  SET hoechster_berufsabschluss_erworben_de = -4
  WHERE  hoechster_berufsabschluss != -1;

--
-- end issue5980
--

