# -*- coding: utf-8 -*-
# Copyright 2007, 2008, 2014 Intevation GmbH, Germany, <info@intevation.de>
# 
# This file is part of mpuls JMD.
# 
# mpuls JMD is free software: you can redistribute it and/or modify it under
# the terms of the GNU Affero General Public License as published by the
# Free Software Foundation, either version 3 of the License, or (at your
# option) any later version.
# 
# mpuls JMD is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Affero General Public
# License for more details.
# 
# You should have received a copy of the GNU Affero General Public
# License along with mpuls JMD. If not, see <http://www.gnu.org/licenses/>.
# 
import logging
from mpulsweb.controllers.mpuls import MpulsController
from jmdstrukturweb.model.appointment import StatisticReminderOverview, TagsReminderOverview
import mpulsweb.lib.helpers as h

log = logging.getLogger(__name__)

class JmdstrukturController(MpulsController):
    
    def get_reminders(self):
        """Return an AppointmentOverview instance with one reminder. It reminds
        the user to create a new statistic.
        """
        remindlist = StatisticReminderOverview()
        
        if h.hasRole(['cm']):
            remindlist.join(TagsReminderOverview())
        
        remindlist.sort()
        
        return remindlist
# vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8:
