# -*- coding: utf-8 -*-
#
# Copyright 2012, 2014 Intevation GmbH, Germany, <info@intevation.de>
#
# This file is part of mpuls JMD
#
# mpuls JMD is free software: you can redistribute it and/or modify it under
# the terms of the GNU Affero General Public License as published by the
# Free Software Foundation, either version 3 of the License, or (at your
# option) any later version.
#
# mpuls JMD is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Affero General Public
# License for more details.
#
# You should have received a copy of the GNU Affero General Public
# License along with mpuls JMD. If not, see <http://www.gnu.org/licenses/>.
#
# Authors:
# Björn Ricks <bjoern.ricks@intevation.de>
# Roland Geider <roland.geider@intevation.de>

"""The application's Globals object"""

import os
import logging

import mpulsweb.lib.app_globals

from formed.meta.io.document import openDocument


log = logging.getLogger(__name__)

class Globals(mpulsweb.lib.app_globals.Globals):

    def __init__(self, config):
        super(Globals, self).__init__(config)

        self.report_template = config.get("mpuls.app.report_template")
        if self.report_template is None:
            raise RuntimeError("mpuls.app.report_template is not configured")
        if not os.path.exists(self.report_template):
            raise RuntimeError("%r, named by mpuls.app.report_template,"
                               " does not exist" % self.report_template)

    def _load_formedtree_from_file(self, formed_file):
        # Build FormedTree. This tree will work as template for all cases
        log.debug("loading formedtree definition with rules for JMD-Strukrur from %r", formed_file)
        return openDocument(formed_file, generate_rules=True)
