## -*- coding: utf-8 -*-
<%inherit file="base.mako" />
<%def name="buildStatusBar()">
  <div id="statusbar">
    ${_('Login as')}:
        ## Instead creating the usersettings link with url_for we
        ## construct the link explicitly because we need to make it
        ## point to the other the normal case setting application.  The
        ## usersettings in the struktur-part only offer limited
        ## functionality and it's confusing for the user when there are
        ## two slightly different user settings pages.
        <a href="${config.get('jmd.otherapp.url').rstrip('/')}/usersettings/showSettings/${h.getUserId()}"
           title="${_('My Account')}"
           onclick="return checkModification();">
    % if h.getLogin() != 'adm':
        <strong>${h.getUserFullname()}</strong></a> (${h.getRole()})
    % else:
        <strong>${h.getUserLastname()}</strong></a>
    % endif
  </div>
</%def>

<%def name="buildStartMenu()">
  <div id="startmenu">
    <ul>
      <li>
        <a href="${h.url('/')}"
           onclick="return checkModification();">
          ${_('Black board')}
        </a>
      </li>
      <li>
          <a href="${h.url(controller='help', action='index')}"
           onclick="return checkModification();">
           ${_('Help')}</a>
      </li>
      <li>
        <a href="${h.url(controller='auth', action='logout')}"
           onclick="return checkModification();">
          ${_('Logout')}</a>
      </li>
    </ul>
  </div>
</%def>

<%def name="buildNavipath()">
  <li><a href="${h.url('/')}"
         onclick="return checkModification();">${_('%s Start') % h.get_app_title()}</a></li>
</%def>

<%def name="buildInfofield()">
</%def>

<%def name="buildPrivacyfield()">
</%def>

<%def name="buildIco()">
  <span class="menuico"> &gt;&gt;</span>
</%def>

<%def name="buildNavigation()">
  % if (h.getLogin() != 'adm'):
    % if h.hasRole(['cm', 'admin']):
      <div class="menu">
        <div class="actions">
          <h1>${_('%s Start') % h.get_app_title()}</h1>
          <ul>
            <li>
              <a href="${h.url('/')}">
                ${_('Black board')}
              </a>
            </li>
            ## APPOINTMENTS 
            % if g.mpuls_config.is_enabled('module', 'appointments'):
              <li>
                <a href="${h.url(controller='appointment',
                                     action='overview')}">
                  ${_('Events')}
                </a>
              </li>
            % endif
            ## DOCUMENTS
            % if g.mpuls_config.is_enabled('module', 'documents'):
              <li>
                <a href="${h.url(controller='document', 
                                     action='globalOverview')}">
                  ${_('Documents')}
                </a>
              </li>
            % endif
          </ul>
        </div>
      </div>
    % endif
    <div class="menu">
      <div class="actions">
        % if g.mpuls_config.is_enabled('module', 'casemanagement'):
          <h1>${_('Case Management')}</h1>
          <ul>
            <li>
              <a href="${h.url(controller='case_overview',
                                   action='overview')}">
                ${_('Case documents	')}
              </a>
            </li>
            % if h.hasRole(['cm']):
              <li>
                <a href="${h.url(controller='case', action='new')}">
                  ${_('New case document')}
                </a> 
              </li>
              % if g.mpuls_config.is_enabled('case-module', 'import'):
                <li>
                  <a href="${h.url(controller='case', action='importCase')}">
                    ${_('Import case document')}
                  </a>
                </li>
              % endif
            % endif
          </ul>
        % endif
      </div>
    </div>
    % if g.mpuls_config.is_enabled('module', 'agency-overview'):
      <div class="menu">
        <div class="actions">
          <h1>${_('Overview')}</h1>
            <ul>
              <li>
                <a href="${h.url(controller='evaluation_overview', action='index')}">
                  ${_('Agency')}
                </a>
              </li>
            </ul>
        </div>
      </div>
    % else:
        <%include file="switch_to_other_datasets.mako" />
    % endif
    % if g.mpuls_config.is_enabled('module', 'evaluation'):
      <div class="menu">
        <div class="actions">
          <h1>${_('Evaluations')}</h1>
          ${self.buildEvaluations()}
        </div>
      </div>
    % endif
    % if h.hasRole(['cm']) and not g.mpuls_config.is_enabled('module', 'agency-overview'):
      <div class="menu">
        <div class="actions">
          <h1>Jahresstatisik</h1>
          <ul>
              <li>
                <a href="${h.url(controller='report', action='doc')}">
                  als .doc erstellen
                </a>
              </li>
            </ul>
        </div>
      </div>
    % endif
    <div class="menu_spacer">
      <div class="actions">
      </div>
    </div>
  % endif
</%def>

<%def name="buildEvaluations()">
  <ul>
    % for eval in g.mpuls_config.get('evaluations', 'enabled'): 
      <li>
        <a href="${h.url(controller='evaluate', action='evaluate',
                             id=eval.get('id'))}">${eval.get('name')}</a>
      </li>
    % endfor
  </ul>
</%def>

<%def name="buildFormErrors(labels=None)">
  <% formular_labels = labels or {} %>
  % if len(c.form_errors) > 0:
    <div class="form_errors">
      <h1><a name="error_list">${_('Wrong formular input')}</a></h1>
      <ul>
        % for key, value in c.form_errors.iteritems():
          <li>${_(formular_labels.get(key, '%s' % key))}: ${value}</li>
        % endfor
      </ul>
    </div>
  % endif
</%def>

<%def name="buildFooter()">
  <div id="footer">
    <div id="version_str">
    <a href="${h.url(controller='info', action='index')}"
           onclick="return checkModification();">
          ${_('Info')}</a>
      | ${g.mpuls_config.get_app_name()}
      | ${g.mpuls_config.get_releasedate()}
      | ${g.mpuls_config.get_app_version()}
    </div>
  </div>
</%def>

<%def name="buildContentHeader()">
  ${self.buildUeberschrift()}
  ${self.buildModusfield()}
</%def>

<%def name="buildUeberschrift()">
</%def>

<%def name="buildModusfield()">
</%def>

<span class="skiplink">
  <a href="#startmenu" title="Direkt zum Hauptmen&#252; springen" 
     tabindex="1">
    Zum Hauptmen&#252; springen
  </a>
</span>
<span class="skiplink">
  <a href="#navigation" title="Direkt zum Bereichsmen&#252; springen" 
     tabindex="1">
    Zum Bereichsmen&#252; springen
  </a>
</span>
<span class="skiplink">
  <a href="#content" title="Direkt zum Inhalt springen" tabindex="2">
    Zum Inhalt springen
  </a>
</span>
<div class="mpuls-block">
  <div class="mpuls-sidebar" id="logo">
    <a href="${h.url('/')}"
       onclick="return checkModification();">
      <img src="${h.url('/images/logos/logo_ka_75.png')}" 
           alt="Logo Einrichtung" border="0">
    </a>
  </div>
  <div class="mpuls-content">
    <div class="mpuls-inner-content">
    ${self.buildStartMenu()}
    ${self.buildStatusBar()}
    <div id="navipath">
      <ul>
        ${self.buildNavipath()}
      </ul>
    </div>
    </div>
  </div>
</div>
<hr>
<div class="mpuls-block" id="main">
  <div class="mpuls-sidebar">
    <div>
      % if h.hasRole(['cm']):
        ${self.buildPrivacyfield()}
      % endif
      ${next.buildNavigation()}
    </div>
  </div>
  <div class="mpuls-content">
    <div class="mpuls-inner-content">
      <div id="content">
        <div id="status_str_nofloat">
        % if c.status_msg:
          <span class="redcolor">${c.status_msg}</span>
        % else:
          <strong>Hinweis:</strong> 
          Gegen ${h.get_logouttime()} Uhr wird diese Sitzung automatisch 
          beendet. Speichern sie bitte vorher Ihre Eingaben!
        % endif
	</div>
      ${self.buildContentHeader()}
      ${self.body()}
      </div>
    </div>
  </div>
</div>
${self.buildFooter()}
