# -*- coding: utf-8 -*-
import logging

from mpulsweb.model.appointment import  MaxSaveTimeReminderOverview , \
     CaseReminderOverview, TagsReminderOverview

from mpulsweb.controllers.mpuls import MpulsController as MpulsMpulsController

import mpulsweb.lib.helpers as h

from jmdweb.model.appointment import MaxAgeReminderOverview, \
     MinAgeReminderOverview, JustBeforeMaxAgeReminderOverview

class MpulsController(MpulsMpulsController):

    def get_reminders(self):
        remindlist = MaxSaveTimeReminderOverview()
        if h.hasRole(['cm']):
            remindlist.join(CaseReminderOverview())

        if h.hasRole(['cm']):
            remindlist.join(TagsReminderOverview())

        if h.hasRole(['cm']):
            remindlist.join(MaxAgeReminderOverview())

        if h.hasRole(['cm']):
            remindlist.join(MinAgeReminderOverview())

        if h.hasRole(['cm']):
            remindlist.join(JustBeforeMaxAgeReminderOverview())

        remindlist.sort()

        return remindlist
