## -*- coding: utf-8 -*-
<%inherit file="../main.mako" />
<%
  formular_labels = {'firstname'  : _('Forename'),
                      'lastname'  : _('Surname'),
                      'login'     : _('Login'),
                      'passwd'    : _('Enter new password'),
                      'passwd2'   : _('Repeat pasword')
                      }
%>

<%def name="buildNavipath()">
  ${parent.buildNavipath()}
  <li><a href="${h.url(controller='administration', action='index')}">${_('Administration')}</a></li>
  <li><a href="${h.url(controller='administration', action='overviewUser')}">${_('User overview')}</a></li>
  <li><a href="${h.url(controller='administration', action='newUser')}">${_('Create new user')}</a></li>
</%def>

<%def name="title()">
    ${h.get_app_title()} - ${_('Create new user')}
</%def>

<div id="content_header_small">
  <div id="content_ueberschrift">${_('Create new user')}</div>
  <div id="modusfield">
    <div class="actions">
      <ul>
        <li>
          <a href="${h.url(controller='administration',
                               action='overviewUser')}">
            ${_('Back to: User overview')}
          </a>
        </li>
      </ul>
    </div>
  </div>
</div>

${self.buildFormErrors(formular_labels)}
<div id="admin_new_user">
  <div id="waska_form">
    <form action="${h.url(controller='administration', action='newUserAction')}"
          method="POST">
      ${ h.csrf_token() }
      <fieldset><legend>${_('Information about personal')}</legend>
        <div class="w25">
          % if c.form_errors.get('firstname'):
            <label for="firstname" class="error_font">
              ${_('Forename')}
            </label>
            <br>
            <input type="text" class="field error_box w100" id="firstname" 
                   name="firstname" maxlength="60">
          % else:
            <label for="firstname">${_('Forename')}</label><br>
            <input type="text" class="field w100" id="firstname" name="firstname"
                   maxlength="64">
          % endif
        </div>
        <div class="w25">
          % if c.form_errors.get('lastname'):
            <label for="lastname" class="error_font">
              ${_('Surname')}
            </label>
            <br>
            <input type="text" class="field error_box w100" id="lasttname" 
                   name="lastname" maxlength="64">
          % else:
            <label for="lastname">${_('Surname')}</label><br>
            <input type="text" class="field w100" id="lasttname" name="lastname" 
                   maxlength="64">
          % endif       
        </div>
        <div class="w25">
          <label for="telephone">${_('Phone')}</label><br>
          <input type="text" class="field w100" id="telephone" name="telephone" 
                 maxlength="32">
        </div>
        <div class="w25">
          <label for="room">${_('Room')}</label><br>
          <input type="text" class="field w100" id="room" name="room" maxlength="16">
        </div>
        <div class="w25">
          <label for="branchoffice">${_('Institution')}</label>
          <br>
          <input type="text" class="field w100" id="branchoffice"
	         name="branchoffice"
                 maxlength="64">
        </div>
      </fieldset>
      % if g.mpuls_config.is_enabled('module', 'agency-overview'):
      <fieldset><legend>${_('Visibility')}</legend>
        <p>
          <label for="agencys">${_('Agency')}</label><br>
          <select id="agencys" name="agencys" size="5" multiple>
            % for agency in c.agency_list:
              <option value="${agency.id}">[${agency.fkz}] - ${agency.name} (${agency.count})</option>
            % endfor
          </select>
        </p>
      </fieldset>
      %endif
      <fieldset><legend>${_('Information about login')}</legend>
        <div class="w25">
          % if c.form_errors.get('login'):
            <label for="login" class="error_font w100">
              ${_('Login')}
            </label>
            <br>
            <input type="text" class="field error_box w100" id="login"
	            name="login" 
                   maxlength="64">
          % else:
            <label for="login">${_('Login')}</label><br>
            <input type="text" class="field w100" id="login" name="login" 
                   maxlength="64">
          % endif
        </div>
        <div class="w25">
          <label for="role">${_('User role')}</label><br>
          <select name="role" id="role" class="w100" style="height:1.6em;">
            % if h.getLogin() != 'adm':
              <option value="cm" >${_('role_user')}</option>
            % endif
            <option value="admin">${_('role_admin')}</option>
          </select>
        </div>
        <div class="repair">
          <p>Für die Anmeldekennung verwenden Sie bitte Kleinbuchstaben von a bis z,
          den Unterstrich "_" und Ziffern (0 bis 9). Nicht zulässig sind
          Großbuchstaben,
          Umlaute(äöüÄÖÜ), Eszett (ß), Leerzeichen, Bindestrich und andere
          Sonderzeichen (z. B. !§$%&/()=?).</p>
          <p>Die Anmeldekennungen "admin", "cm", "pb" und "adm" sind ebenfalls
          nicht erlaubt.</p>
        </div>
        <div class="w25">
          <input type="checkbox" name="activated" id="activated" value="1" 
                 checked>
          <label for="activated">${_('User is allowed to activate')}</label>
        </div>
        <div class="w100">
          <input type="checkbox" name="newpass" id="newpass" value="1" checked>
          <label for="newpass">${_('User must set password at next login.')}</label>
        </div>
      </fieldset>
      <input class="button" type="submit" value="${_('Save user')}">
    </form>
  </div>
</div>
