## -*- coding: utf-8 -*-
<%inherit file="main.mako" />
<%!  import mpulsweb.lib.helper.filters as F %>
<%def name="buildNavipath()">
    ${parent.buildNavipath()}
    <li><a href="${h.url(controller='case', action='select', id=session.get('case').id, confirmed=1)}">${_('Selected case documents')}</a></li>
    <li><a href="${h.url(controller='case', action='organisation', id=session.get('case').id)}">${_('Organisation')}</a></li>
</%def>

<%def name="title()">
    ${h.get_app_title()} - ${_('Organisation')}
</%def>

<div id="content_header_small">
  <div id="content_ueberschrift">
    ${_('Organisation')}
  </div>
</div>
<p>${_('This page shows the main worker of a case document and his or her standin')}</p>
<h2>${_('Editor')}</h2>
<table>
  <tr>
    <td class="label table_header_v table_width_mid_l">${_('Lastname')}</td><td class=" table_row_v">${c.editor.last_name | F.NA}</td>
    </tr>
  <tr>
    <td class="label">${_('Firstname')}</td><td class=" table_row_v_2">${c.editor.first_name | F.NA}
    </td>
  </tr>
  <tr>
    <td class="label table_header_v">${_('Phone')}</td><td class=" table_row_v">${c.editor.telephone | F.NA}
    </td>
  </tr>
</table>
% if h.hasRole(['admin']) and session.get('case').getState().getState() == 1:
<form action="${h.url(controller="case", action="setEditorAction")}" method="POST">
${ h.csrf_token() }
<input type="hidden" name="case_id" value="${session.get('case').id}">
<select name="editor">
% for user in c.user_list:
  <option value="${user.id | F.NA}">${user.last_name | F.NA}, ${user.first_name | F.NA}</option>
% endfor
</select>
<input class="button" type="submit" value="${_('Case document assigned')}">
</form>
% endif

<div id="content_bottom"><h2>${_('Standin')}</h2></div>

% if ((h.hasRole(['admin']) or (c.current_user.id == c.editor.id))) and session.get('case').getState().getState() == 1:
<form action="${h.url(controller="case", action="setStandinAction")}" method="POST">
${ h.csrf_token() }
<input type="hidden" name="case_id" value="${session.get('case').id}">
<input type="checkbox" name="mpuls-toggle-all-standin"
       id="mpuls-toggle-all-standin"
       ><label for="mpuls-toggle-all-standin">${_('Select/deselect all standins')}</label>
<div class="repair">
  <table class="table table-condensed">
   <thead>
    <tr>
      <th class="table_header_h table_checkbox">&nbsp;</th>
      <th class="table_header_h table_description">${_('Editor')}</th>
    </tr>
   </thead>
    % for (num, group) in enumerate(c.group_list):
    <tr class="${num % 2 and 'table_row_v_12' or ''}">
      <td><input type="checkbox" name="standin" value="${group.id}"
                 ${group.id in c.standin.getGroups() and 'checked' or '' | n}></td>
      <td>${group.name | F.NA}</td>
    </tr>
    % endfor
  </table>
</div>
<input class="button" type="submit" value="${_('Change Standin')}">
</form>
% else:
<table>
  <tr>
    <th class="table_width_long table_header_h">${_('Editor')}</th>
  </tr>
  <% standins = [g for g in c.group_list2 if g.id in c.standin.getGroups()] %>
  % for (num, group) in enumerate(standins):
  <tr class="${num % 2 and 'table_row_h' or 'table_row_h2'}">
    <td>${group.name | F.NA}</td>
  </tr>
  % endfor
</table>
% endif
