## -*- coding: utf-8 -*-
<%inherit file="../casemanagement/main.mako" />

<%def name="title()">
    ${h.get_app_title()} - ${_('Document overview')}
</%def>

<%def name="buildNavipath()">
  ${parent.buildNavipath()}
  <li>
    <a href="${h.url(controller='case', action='select', id=session.get('case').id, confirmed=1)}">
      ${_('Selected case documents')}
    </a>
  </li>
  <li>
    <a href="${h.url(controller='casedocument', action='index', id=session.get('case').id)}">
      ${_('Documents overview')}
    </a>
  </li>
</%def>

<div id="content_header_small">
  <div id="content_ueberschrift">
    ${_('Document overview')}
  </div>
  % if h.hasRole(['cm']) and session.get('case').getState().getState() == 1:
    <div id="modusfield">
      <div class="actions">
    <ul>
      <li><a href="${h.url(controller='casedocument', action='new', id=session['case'].id)}">${_('Add attachment')}</a></li>
    </ul>
      </div>
    </div>
  % endif
</div>

<%!  import mpulsweb.lib.helper.filters as F %>
<div class="repair">
<table id="table_caseoverview" class="table table-condensed table-hover">
 <thead>
  <tr>
    <th class="table_header_h table_width_filename">
      ${_('Filename')}
    </th>
    <th class="table_header_h">
      ${_('Inserted at')}
    </th>
    <th class="table_header_h">
      ${_('Filesize')}
    </th>
    <th class="table_header_h table_actions text-center">
      ${_('Actions')}
    </th>
  </tr>
  </thead>
  % if len(c.files) > 0:
    <%
      kb = lambda x: h.format_number(x * 1.0/1024.0)
    %>
    % for num, f in enumerate(c.files):
    <tr>
      <td>
          <a href="${h.url(controller='casedocument', action='show', id=f.id, url=f.getName())}"
             target="_blank"
             >${ F.shorten(f.getName(),60) }
          </a>
          % if g.mpuls_config.is_enabled("module", "documents-description"):
            <div class="description">${f.description}</div>
          % endif
      </td>
      <td>
        ${h.NA(h.format_date(f.insert_date))}
      </td>
      <td>
          ${kb(f.size)} KB
      </td>
      <td class="text-center">
          <a href="${h.url(controller='casedocument', action='show', id=f.id, url=f.getName())}"
             target="_blank"
             ><img src="${h.url('/images/icons/open_active_22.png')}" border="0" alt="${_('Show')}"
                   title="${_('Show')}" title="${_('Show')}">
          </a>
      % if h.hasRole(['cm']):
          <a href="${h.url(controller='casedocument', action='rename', id=f.id)}">
              <img src="${h.url('/images/icons/edit_22.png')}" border="0"
                   alt="${_('Rename')}" title="${_('Rename')}">
          </a>

      % endif
          % if h.hasRole(['cm']) and session.get('case').getState().getState() == 1:
            <a href="${h.url(controller='casedocument', action='delete', id=f.id, confirmed=0)}">
              <img src="${h.url('/images/icons/delete_active_22.png')}" border="0"
              alt="${_('Delete')}"
              title="${_('Delete')}">
            </a>
          % endif
      </td>
    </tr>
    % endfor
  % else:
    <tr>
      <td colspan="4">
        ${_('No files found')}
      </td>
    </tr>
  % endif
</table>
</div>
