## -*- coding: utf-8 -*-
<%inherit file="../main.mako" />

<h1>Fallschlüssel</h1>
<p>
Hier sehen Sie die Auswertung zur Ermittlung ihres Fallschlüssels.  Die
Auswertung erfolgt über einen Zeitraum der letzten ${len(c.percentages)} Monate
ab dem ${c.percentages[0][0].strftime('01.%m.%Y')}. Die Berechnung erfolgt auf
Basis der CM- und ggf. Beratungsfällen in diesem Zeitraum.</p>
<h2>Entwicklung Fallzahlen</h2>
<p>
Sehen Sie hier die Entwicklung der zur Berechnung relevanten Fälle über den Auswertungszeitraum.
</p>
<table>
<tr>
  <th>Monat</th>
  <th>Fälle</th>
</tr>
% for per in c.percentages:
  <tr>
    <td>${per[0].strftime('%m.%Y')}</td>
    <td>${per[1]}</td>
  </tr>
% endfor
</table>
<h2>Berechnung Fallschlüssel</h2>
<p>
Die Berechnung des Fallschlüssel erfolgt auf Basis des Mittelwerts der
relevanten Fälle über den Auswertungsszeitraum und des <u>aktuell</u>
eingetragenen CM Stellenanteils aus den Einrichtungseinstellungen.
</p>
<table>
  <tr>
    <% total_cases = sum([p[1] for p in c.percentages]) %>
    <td class="label">Teilnehmer Gesamt</td>
    <td>${total_cases}</td>
  </tr>
  <tr>
    <% months = len(c.percentages) %>
    <td class="label">Anzahl der Monate</td>
    <td>${months}</td>
  </tr>
  <tr>
    <% avg_cases = total_cases/float(months) %>
    <td class="label">Teilnehmer pro Monat</td>
    <td>${h.format_number(avg_cases)}</td>
  </tr>
  <tr>
    <td class="label">CM Stellen</td>
    % if c.display_jobpercentage:
    <td>${h.format_number(c.jobpercentage)}</td>
    % else:
    <td>0</td>
    % endif
  </tr>
  <tr>
    <td class="label"><strong>Fallschlüssel</strong></td>
  % if c.display_jobpercentage:
    <td><strong>${h.format_number(avg_cases/c.jobpercentage)}</strong></td>
  % else:
    <td><strong>Kann ohne CM Stellen nicht berechnet werden.</strong></td>
  % endif
  </tr>
</table>
