SET ROLE :adm_ka_owner;
BEGIN;

CREATE OR REPLACE VIEW ka_status_tbl_view AS 
SELECT
	ka_status_tbl.id,
	ka_status_tbl.master_id,
	ka_status_tbl.status, 
	ka_status_tbl.zugriff,
	ka_status_tbl.erstellt,
	ka_status_tbl.anonymisiert
FROM ka_status_tbl;

CREATE OR REPLACE RULE ka_status_delete_rule AS ON DELETE TO 
ka_status_tbl_view DO INSTEAD NOTHING;

CREATE OR REPLACE RULE ka_status_insert_rule AS ON INSERT TO 
ka_status_tbl_view DO INSTEAD NOTHING;

CREATE OR REPLACE RULE ka_status_update_rule AS ON UPDATE TO ka_status_tbl_view 
	DO INSTEAD UPDATE ka_status_tbl SET
	status  = new.status,
	zugriff = new.zugriff,
	anonymisiert = new.anonymisiert
WHERE id = new.id;

GRANT SELECT ON ka_status_tbl_view TO GROUP :cm_group;
GRANT UPDATE ON ka_status_tbl_view TO GROUP :cm_group;
GRANT SELECT ON ka_status_tbl_view TO GROUP :admin_group;
GRANT UPDATE ON ka_status_tbl_view TO GROUP :admin_group;

COMMIT;

