SET ROLE :adm_ka_owner;
BEGIN;
-- 
-- Sicht auf die Termine Tabelle 
--

CREATE OR REPLACE VIEW ka_global_termine_tbl_view AS 
SELECT ka_termine_tbl.id, ka_termine_tbl.master_id, ka_termine_tbl.sdatum, 
ka_termine_tbl.edatum, ka_termine_tbl.name, ka_termine_tbl.beschreibung, ka_termine_tbl.art
FROM ka_termine_tbl WHERE ka_termine_tbl.master_id is NULL;

CREATE OR REPLACE RULE ka_global_termine_delete_rule AS ON DELETE TO 
ka_global_termine_tbl_view DO INSTEAD NOTHING;

CREATE OR REPLACE RULE ka_global_termine_insert_rule AS ON INSERT TO 
ka_global_termine_tbl_view DO INSTEAD NOTHING;

CREATE OR REPLACE RULE ka_global_termine_update_rule AS ON UPDATE TO ka_global_termine_tbl_view 
	DO INSTEAD  UPDATE ka_termine_tbl SET 
	sdatum = new.sdatum, 
	edatum = new.edatum, 
	name = new.name,
	beschreibung = new.beschreibung,
	art = new.art
	WHERE ka_termine_tbl.id = new.id;

GRANT SELECT ON ka_global_termine_tbl_view TO GROUP :cm_group;
GRANT SELECT ON ka_global_termine_tbl_view TO GROUP :admin_group;
GRANT UPDATE ON ka_global_termine_tbl_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW ka_fall_termine_tbl_view AS 
SELECT ka_termine_tbl.id, ka_termine_tbl.master_id,
ka_termine_tbl.sdatum, ka_termine_tbl.edatum,
ka_termine_tbl.name, ka_termine_tbl.beschreibung, ka_termine_tbl.art FROM ka_termine_tbl 
INNER JOIN master_tbl ON
ka_termine_tbl.master_id = master_tbl.id 
WHERE master_tbl.bearbeiter_id = getuserid()
    OR master_tbl.id IN (
        SELECT nm.master_id from nm_benutzer_master_tbl nm
        WHERE nm.benutzer_id IN (
            SELECT nm2.gruppe_id from nm_benutzer_gruppe_tbl nm2 
            WHERE nm2.benutzer_id = getuserid()
        )
    )
    OR pg_has_role('admin','MEMBER');

CREATE OR REPLACE RULE ka_fall_termine_delete_rule AS ON DELETE TO 
ka_fall_termine_tbl_view DO INSTEAD NOTHING;

CREATE OR REPLACE RULE ka_fall_termine_insert_rule AS ON INSERT TO 
ka_fall_termine_tbl_view DO INSTEAD NOTHING;

CREATE OR REPLACE RULE ka_fall_termine_update_rule AS ON UPDATE TO ka_fall_termine_tbl_view 
	DO INSTEAD  UPDATE ka_termine_tbl SET 
	sdatum = new.sdatum, 
	edatum = new.edatum, 
	name = new.name,
	beschreibung = new.beschreibung,
	art = new.art
	WHERE ka_termine_tbl.id = new.id;

GRANT SELECT ON ka_fall_termine_tbl_view TO GROUP :cm_group;
GRANT UPDATE ON ka_fall_termine_tbl_view TO GROUP :cm_group;
GRANT SELECT ON ka_fall_termine_tbl_view TO GROUP :admin_group;

COMMIT;
